#!/usr/bin/env ruby

# Run it like this:
#
#   ./codegen/lzotypedtsv_generator.rb > src/main/scala/com/twitter/scalding/commons/source/GeneratedLzoTypedTsv.scala

$indent = "  "

TYPES = ('A'..'Z').to_a

def make_typed_tsv(cnt)
  other_cnts = (1..(22-cnt)).to_a
  typeString = TYPES[0..(cnt - 1)].join(",")
  puts "trait LzoTypedTsv#{cnt}[#{typeString}] extends LzoTypedTsv[Tuple#{cnt}[#{typeString}]] with Mappable#{cnt}[#{typeString}]"
end

puts "// following were autogenerated by #{__FILE__} at #{Time.now} do not edit"
puts %q|package com.twitter.scalding.commons.source

import com.twitter.scalding._

|

(1..22).each { |c|
  make_typed_tsv(c)
  puts
}

puts "// end of autogenerated"
